#ifndef __CACHE_CACHE_H__
#define __CACHE_CACHE_H__

#include <utility/types.h>
#include <utility/list.h>
#include <scheduler/mutex.h>
#include <cache/slab.h>

typedef struct Cache
{
   ListNode		cacheList;
   Mutex                lock;
   Slab *		slabNotEmpty;
   List			slabsUsed;
   List			slabsFree;
   Size			objectSize;
} Cache;

extern Bool	cache_create 	(Cache *, Size);
extern void	cache_destroy 	(Cache *);

extern void *	cache_allocate	(Cache *);
extern void	cache_free	(Cache *, void *);
extern Size	cache_flush	(Cache *, Size);
extern Size	cache_reap	(Size);

#endif /* __CACHE_CACHE_H__ */

