#ifndef __CANVAS_TYPE_H__
#define __CANVAS_TYPE_H__

#include <canvas/canvas.h>

typedef struct CanvasType
{
     void (* line) (Canvas *, CanvasColor, const CanvasPoint *, const CanvasPoint *);
     void (* horizontalLine) (Canvas *, CanvasColor, const CanvasPoint *, Size);
     void (* verticalLine) (Canvas *, CanvasColor, const CanvasPoint *, Size);
     void (* points) (Canvas *, CanvasColor, const CanvasPoint *, Size);
     void (* rectangle) (Canvas *, CanvasColor, const CanvasArea *);
     void (* triangle) (Canvas *, CanvasColor, const CanvasPoint *, const CanvasPoint *, const CanvasPoint *);
     void (* polygon) (Canvas *, CanvasColor, const CanvasPoint *, Size);
     void (* fill) (Canvas *, CanvasColor);
     void (* blit) (Canvas *, const CanvasArea *, void *);
     void (* bitmap) (Canvas *, CanvasColor, const CanvasArea *, void *);
} CanvasType;

#endif /* __CANVAS_TYPE_H__ */

