#ifndef __CONSOLE_TYPE_H__
#define __CONSOLE_TYPE_H__

#include <console/console.h>

typedef struct ConsoleType
{
        Bool (* create) (Console *, ConsoleCoordinate, ConsoleCoordinate);
        void (* destroy) (Console *);
        void (* activate) (Console *);
        void (* deactivate) (Console *);
        void (* setCursor) (Console *, ConsoleCoordinate, ConsoleCoordinate);
        void (* renderLine) (Console *, 
                             ConsoleCoordinate, 
                             Size, 
                             const uint16 *);
} ConsoleType;

extern ConsoleType * CONSOLE_TYPE_VGA;
extern ConsoleType * CONSOLE_TYPE_DEFAULT;

#endif /* __CONSOLE_TYPE_H__ */

