%ifndef __I386_FPU_I__
%define __I386_FPU_I__

I386_FPU_STATE_INITIALIZE       equ 0
I386_FPU_STATE_SAVE             equ 1
I386_FPU_STATE_RESTORE          equ 2

I386_FPU_STATUS_INVALID_OPERATION     equ (1 << 0)
I386_FPU_STATUS_DENORMALIZED_OPERATND equ (1 << 1)
I386_FPU_STATUS_ZERO_DIVIDE_EXCEPTION equ (1 << 2)
I386_FPU_STATUS_OVERFLOW_EXCEPTION    equ (1 << 3)
I386_FPU_STATUS_UNDERFLOW_EXCEPTION   equ (1 << 4)
I386_FPU_STATUS_PRECISION_EXCEPTION   equ (1 << 5)
I386_FPU_STATUS_STACK_FAULT           equ (1 << 6)
I386_FPU_STATUS_ERROR_SUMMARY         equ (1 << 7)
I386_FPU_STATUS_CONDITION_CODE_0      equ (1 << 8)
I386_FPU_STATUS_CONDITION_CODE_1      equ (1 << 9)
I386_FPU_STATUS_CONDITION_CODE_2      equ (1 << 10)
I386_FPU_STATUS_TOP_OF_STACK          equ (3 << 11)
I386_FPU_STATUS_CONDITION_CODE_3      equ (1 << 14)
I386_FPU_STATUS_BUSY                  equ (1 << 15)

I386_FPU_CONTROL_INVALID_OPERATION     equ (1 << 0)
I386_FPU_CONTROL_DENORMALIZED_OPERAND  equ (1 << 1)
I386_FPU_CONTROL_ZERO_DIVIDE_EXCEPTION equ (1 << 2)
I386_FPU_CONTROL_OVERFLOW_EXCEPTION    equ (1 << 3)
I386_FPU_CONTROL_UNDERFLOW_EXCEPTION   equ (1 << 4)
I386_FPU_CONTROL_PRECISION_EXCEPTION   equ (1 << 5)
I386_FPU_CONTROL_PRECISION_TYPE        equ (3 << 8)
I386_FPU_CONTROL_ROUNDING_TYPE         equ (3 << 10)
I386_FPU_CONTROL_INFINITY_CONTROL      equ (1 << 12)

I386_FPU_PRECISION_SINGLE   equ (0 << 8)
I386_FPU_PRECISION_DOUBLE   equ (2 << 8)
I386_FPU_PRECISION_EXTENDED equ (3 << 8)

I386_FPU_ROUNDING_NEAREST   equ (0 << 10)
I386_FPU_ROUNDING_DOWN      equ (1 << 10)
I386_FPU_ROUNDING_UP        equ (2 << 10)
I386_FPU_ROUNDING_TRUNCATE  equ (3 << 10)
I386_FPU_ROUNDING_MASK      equ (3 << 10)

I386_FPU_TAG_VALID   equ 0
I386_FPU_TAG_ZERO    equ 1
I386_FPU_TAG_SPECIAL equ 2
I386_FPU_TAG_EMPTY   equ 3
            
struc i386FPUContext
        .control        resd 1
        .status         resd 1
        .tag            resd 1
        .eip            resd 1
        .cs             resd 1
        .opCode         resd 1
        .data           resd 1
        .ds             resd 1
        .registers      resb 10 * 8
        .state          resd 1
        .size
endstruc

%endif

