%include "utility/assembly.i"

section .text read nowrite exec contents

FUNCTION i386_get_IDTR
	sub	esp, 8
	sidt	[esp]
	
	xor	eax, eax
	mov	ax, [esp]
	shr	eax, 3
	
	mov	ecx, [esp + 16]
	mov	[ecx], eax
	
	mov	eax, [esp + 2]
	mov	ecx, [esp + 12]
	mov	[ecx], eax

	add	esp, 8
	ret
FUNCTION_END

	
FUNCTION i386_set_IDTR
	sub	esp, 8

	mov	eax, [esp + 12]
	mov	[esp + 2], eax
	
	mov	eax, [esp + 16]
        shl     eax, 3
	mov	[esp], ax

	lidt	[esp]
	add	esp, 8
	ret
FUNCTION_END


FUNCTION i386_get_GDTR
        sub     esp, 8
        sgdt    [esp]
        
        xor     eax, eax
        mov     ax, [esp]
        shr     eax, 3

        mov     ecx, [esp + 16]
        mov     [ecx], eax

        mov     eax, [esp + 2]
        mov     ecx, [esp + 12]
        mov     [ecx], eax

        add     esp, 8
        ret
FUNCTION_END


FUNCTION i386_set_GDTR
        sub     esp, 8

        mov     eax, [esp + 12]
        mov     [esp + 2], eax

        mov     eax, [esp + 16]
        shl     eax, 3
        mov     [esp], ax

        lgdt    [esp]
        add     esp, 8
        ret
FUNCTION_END

       
FUNCTION i386_set_LDTR
        lldt    word [esp + 4]
        ret
FUNCTION_END

        
FUNCTION i386_get_LDTR
        sldt    ax
        ret
FUNCTION_END


FUNCTION i386_set_TR
        ltr     word [esp + 4]
        ret
FUNCTION_END

        
FUNCTION i386_get_TR
        str     ax
        ret
FUNCTION_END


FUNCTION i386_set_CR0
        mov     eax, [esp + 4]
        mov     cr0, eax
        ret
FUNCTION_END


FUNCTION i386_get_CR0
        mov     eax, cr0
        ret
FUNCTION_END


FUNCTION i386_set_CR2
        mov     eax, [esp + 4]
        mov     cr2, eax
        ret
FUNCTION_END


FUNCTION i386_get_CR2
        mov     eax, cr2
        ret
FUNCTION_END


FUNCTION i386_set_CR3
        mov     eax, [esp + 4]
        mov     cr3, eax
        ret
FUNCTION_END


FUNCTION i386_get_CR3
        mov     eax, cr3
        ret
FUNCTION_END


FUNCTION i386_set_CR4
        mov     eax, [esp + 4]
        mov     cr4, eax
        ret
FUNCTION_END


FUNCTION i386_get_CR4
        mov     eax, cr4
        ret
FUNCTION_END


FUNCTION i386_atomic_test_and_set
	mov	eax, [esp + 4]
	lock
        bts	dword [eax], 0
        sbb     eax, eax
        and     eax, 1
	ret
FUNCTION_END


FUNCTION i386_interrupts_enable
        sti
        ret
FUNCTION_END


FUNCTION i386_interrupts_disable
	cli
	ret
FUNCTION_END


FUNCTION i386_interrupt_wait
        pushf
        sti
        hlt
        popf
        ret
FUNCTION_END


FUNCTION i386_invalidate_page
        mov     eax, [esp + 4]
        invlpg  [eax]
        ret
FUNCTION_END

        
FUNCTION i386_clear_task_switched
        clts
        ret
FUNCTION_END

