#include <libc/ctype.h>

int
toascii (int c)
{ 
  return (c & 0x7F); 
}

int
toupper (int c)
{ 
  if (islower (c) != 0)
    c += ('A' - 'a');

  return c;
}

int
tolower (int c)
{
  if (isupper (c) != 0)
    c -= ('A' - 'a');

  return c;
}

int
isalpha (int c)
{
  return isupper (c) | islower (c);
}

int
isascii (int c)
{
  return (c <= 0x7F);
}

int
isalnum (int c)
{
  return isalpha (c) | isdigit (c);
}

int
isdigit (int c)
{
  return (c >= '0') & (c <= '9');
}

int
islower (int c)
{
  return (c >= 'a') & (c <= 'z');
}

int
isupper (int c)
{
  return (c >= 'A') & (c <= 'Z');
}

int
ispunct (int c)
{
  return isprint (c) &&
         ! isspace (c) &&
         ! isalnum (c);
}

int
isgraph (int c)
{
  return ((c >= '!') & (c <= '/')) ||
	 ((c >= ':') & (c <= '@')) ||
	 ((c >= '[') & (c <= '`')) ||
	 ((c >= '{') & (c <= '~')) ||
	 ((c >= 161) & (c <= 191));
}

int
isspace (int c)
{
  return (c == ' ') ||
         (c == '\f') ||
	 (c == '\n') ||
	 (c == '\r') ||
	 (c == '\t') ||
	 (c == '\v');
}

int
isblank (int c)
{
  return (c == ' ') | (c == '\t');
}

int
isxdigit (int c)
{
  return isdigit (c) ||
	 ((c >= 'a') & (c <= 'f')) ||
	 ((c >= 'A') & (c <= 'F'));
}

int
isprint (int c)
{
   return (c >= ' ' && c <= '~');
}

