#include <libc/math.h>

double
cosh (double x)
{
    return (exp (x) + exp (-x)) / 2;
}

double
sinh (double x)
{
    return (exp (x) - exp (-x)) / 2;
}

double
tanh (double x)
{
    double u = exp (x),
           v = exp (-x);
    
    return (u - v) / (u + v);
}

double
acosh (double x)
{
    return log (x + sqrt (x * x - 1.0));
}

double
asinh (double x)
{
    return log (x + sqrt (x * x + 1.0));
}

double
atanh (double x)
{
    return asinh (x) / acosh (x);
}

