%include "utility/assembly.i"
%include "scheduler/registers.i"

section .text read nowrite exec contents

FUNCTION setjmp
        mov     eax, [esp + 4]

        mov     [eax + ThreadRegisters.EAX], dword 1
        mov     [eax + ThreadRegisters.ECX], ecx
        mov     [eax + ThreadRegisters.EDX], edx
        mov     [eax + ThreadRegisters.EBX], ebx
        mov     [eax + ThreadRegisters.ESP], esp
        mov     [eax + ThreadRegisters.EBP], ebp
        mov     [eax + ThreadRegisters.ESI], esi
        mov     [eax + ThreadRegisters.EDI], edi

        mov     ecx, [esp]
        mov     [eax + ThreadRegisters.EIP], ecx

        xor     eax, eax
        ret
FUNCTION_END

        
FUNCTION longjmp
        mov     eax, [esp + 1 * 4]
        mov     ecx, [esp + 2 * 4]

        test    ecx, ecx
        jnz     .loadRegisters

        mov     [eax + ThreadRegisters.EAX], ecx

.loadRegisters:
        mov     edx, [esp]
        mov     esp, [eax + ThreadRegisters.ESP]
        mov     [esp], edx

        mov     ecx, [eax + ThreadRegisters.ECX]
        mov     edx, [eax + ThreadRegisters.EDX]
        mov     ebx, [eax + ThreadRegisters.EBX]
        mov     ebp, [eax + ThreadRegisters.EBP]
        mov     esi, [eax + ThreadRegisters.ESI]
        mov     edi, [eax + ThreadRegisters.EDI]
        
        mov     eax, [eax + ThreadRegisters.EAX]
        ret
FUNCTION_END

        
