#ifndef __LIBC_STDLIB_H__
#define __LIBC_STDLIB_H__

#include <utility/types.h>
#include <libc/sys/types.h>
#include <libc/limits.h>

enum
{
	EXIT_SUCCESS = 0,
	EXIT_FAILURE = 1
};

enum
{
	RAND_MAX	= INT_MAX
};

extern char *	getenv	(const char *);
extern int	system	(const char *);

extern int	atoi	(const char *);

extern void *	calloc	(size_t, size_t);
extern void *	malloc	(size_t);
extern void *	realloc (void *, size_t);
extern void 	free	(void *);

extern void	abort	(void);
extern void	exit	(int);

extern int	rand	(void);
extern void	srand	(unsigned);

#endif /* __LIBC_STDLIB_H__ */

