#ifndef __LIBC_SYS_TYPES_H__
#define __LIBC_SYS_TYPES_H__

#include <utility/types.h>
#include <utility/memory.h>

typedef Size size_t;

#define FD_SETSIZE 256

typedef struct
{
        uint8 fds_bits [FD_SETSIZE / 8];
} fd_set;
        
#define FD_ZERO(set) \
        ((void) memory_zero ((set), sizeof (fd_set)))

#define FD_CLR(fd, set) \
        ((void) ((set) -> fds_bits [(fd) / 8] &= ~ (1 << ((fd) % 8))))

#define FS_SET(fd, set) \
        ((void) ((set) -> fds_bits [(fd) / 8] |= (1 << ((fd) % 8))))

#define FD_ISSET(fd, set) \
        ((int) ((set) -> fds_bits [(fd) / 8] & (1 << ((fd) % 8))))       

#endif /* __LIBC_SYS_TYPES_H__ */

