#ifndef __LIBC_TIME_H__
#define __LIBC_TIME_H__

#include <utility/types.h>
#include <timer/timer.h>

typedef Seconds         time_t;
typedef MicroSeconds    clock_t;

enum
{
	CLOCKS_PER_SEC = MICROSECONDS_PER_SECOND
};

struct timespec
{
        time_t  tv_sec;
        long    tv_nsec;
};

extern clock_t	clock	        (void);
extern time_t	time	        (time_t *);

extern int      nanosleep       (const struct timespec *, struct timespec *);

extern char *   ctime           (const time_t *);

#endif /* __LIBC_TIME_H__ */

