#ifndef __LINKER_IMPORT_H__
#define __LINKER_IMPORT_H__

#include <utility/list.h>
#include <linker/export.h>

struct Component;

typedef enum
{
        IMPORT_TYPE_UNKNOWN  = EXPORT_TYPE_UNKNOWN,
        IMPORT_TYPE_DATA     = EXPORT_TYPE_DATA,
        IMPORT_TYPE_FUNCTION = EXPORT_TYPE_FUNCTION,
        IMPORT_TYPE_SECTION  = EXPORT_TYPE_SECTION
} ImportType;

typedef struct Import
{
        ListNode         importList;
        const char *     interface;
        const char *     name;
        ImportType       type;
        Export *         export;
        Size             relocationCount;
} Import;

extern Bool     import_create   (Import **, struct Component *, const char *, const char *, ImportType);
extern void     import_destroy  (Import *);


#endif /* __LINKER_IMPORT_H__ */

