#include <memory/memory.h>
#include <linker/component.h>
#include <linker/interface.h>

Bool
interface_create (Interface ** result, Component * component, const char * name)
{
        Interface * interface = (Interface *) memory_allocate (sizeof (Interface));

        if (interface == NULL)
          return FALSE;

        interface -> component = component;
        interface -> name      = name;

        list_insert_back (& component -> interfaces, interface);

        if (result != NULL)
          * result = interface;

        return TRUE;
}

void
interface_destroy (Interface * interface)
{
        list_remove (& interface -> interfaceList);

        memory_free (interface);
}

