#ifndef __LINKER_LINKER_H__
#define __LINKER_LINKER_H__

#include <utility/list.h>
#include <scheduler/mutex.h>
#include <linker/export.h>
#include <linker/interface.h>
#include <linker/component.h>

typedef struct Linker
{
        Mutex   lock;
        List    components;
} Linker;

extern Bool             linker_create   (Linker *);
extern void             linker_destroy  (Linker *);

extern Linker *         linker_current          (void);
extern void             linker_activate         (Linker *);

extern Export *         linker_find_export      (const char *, const char *);
extern Interface *      linker_find_interface   (const char *);
extern Component *      linker_find_component   (const char *);

#endif /* __LINKER_LINKER_H__ */

