#include <linker/import.h>
#include <linker/export.h>
#include <linker/section.h>
#include <linker/relocation.h>

Bool
relocation_create (Relocation * relocation, RelocationType type, Import * import, Address offset, Address addend)
{
        relocation -> type   = type;
        relocation -> import = import;
        relocation -> offset = offset;
        relocation -> addend = addend;
       
        ++ import -> relocationCount;

        return TRUE;
}

void
relocation_relocate (Relocation * relocation, Section * section)
{
        Export * export = relocation -> import -> export;
        Address value   = (Address) export -> section -> data + export -> offset;
        uint8 * target  = & section -> data [relocation -> offset];

        switch (relocation -> type)
        {
        case RELOCATION_TYPE_I386_ABSOLUTE_16:
             * (uint16 *) target += (uint16) value;
             
             break;
             
        case RELOCATION_TYPE_I386_ABSOLUTE_32:
             * (uint32 *) target += (uint32) value;
             
             break;

        case RELOCATION_TYPE_I386_RELATIVE_8:
             * (uint8 *) target += (uint8) (value - (Address) target);

             break;

        case RELOCATION_TYPE_I386_RELATIVE_16:
             * (uint16 *) target += (uint16) (value - (Address) target);

             break;

        case RELOCATION_TYPE_I386_RELATIVE_32:
             * (uint32 *) target += (uint32) (value - (Address) target);
             
             break;

        default:
             break;
        }
}

