#ifndef __PCI_BIOS_32_H__
#define __PCI_BIOS_32_H__

#include <pci/bios.h>

enum
{
   PCI_BIOS32_SERVICE_DIRECTORY_OFFSET = 0xE0000,
   PCI_BIOS32_SERVICE_DIRECTORY_LIMIT  = 0x100000
};

enum
{
   PCI_BIOS32_SERVICE_DIRECTORY_SIGNATURE = '_' + ('3' << 8) + ('2' << 16) + ('_' << 24),
   PCI_BIOS32_SERVICE_DIRECTORY_CHECKSUM  = 0
};

typedef struct
{
	uint32	signature;
	uint32	entryPoint;
	uint8	revisionLevel;
	uint8	directoryLength;
	uint8	checksum;
	uint8	reserved [5];
} PCIBios32ServiceDirectory;

extern PCIBios32ServiceDirectory * pci_bios32_find_service_directory (void);

#endif /* __PCI_BIOS32_H__ */

