#ifndef __SCHEDULER_SEMAPHORE_H__
#define __SCHEDULER_SEMAPHORE_H__

#include <timer/timer.h>
#include <scheduler/spinlock.h>
#include <scheduler/thread.h>

typedef struct
{
        Spinlock        lock;
	Size            count;
	List            waitingThreads;
} Semaphore;

extern Bool semaphore_create 	(Semaphore *, Size);
extern void semaphore_destroy	(Semaphore *);

extern Size semaphore_down	 (Semaphore *);
extern Size semaphore_timed_down (Semaphore *, TimeOffset *);
extern Size semaphore_try_down	 (Semaphore *);
extern Size semaphore_up	 (Semaphore *);

#endif /* __SCHEDULER_SEMAPHORE_H__ */

