#ifndef __SCHEDULER_SPINLOCK_H__
#define __SCHEDULER_SPINLOCK_H__

#include <utility/types.h>
#include <utility/inline.h>
#include <i386/manage.h>

typedef struct
{
	Bool	locked;
} Spinlock;

INLINE Bool	spinlock_create		(Spinlock * spinlock)
{
   spinlock -> locked = FALSE;

   return TRUE;
}

INLINE void	spinlock_destroy	(Spinlock * spinlock)
{}

INLINE void	spinlock_lock		(Spinlock * spinlock)
{
   while (i386_atomic_test_and_set (& spinlock -> locked) == TRUE);
}

INLINE Bool	spinlock_try_lock	(Spinlock * spinlock)
{
   return i386_atomic_test_and_set (& spinlock -> locked);
}

INLINE void	spinlock_unlock		(Spinlock * spinlock)
{
   spinlock -> locked = FALSE;
}

#endif /* __SCHEDULER_SPINLOCK_H__ */

