#ifndef __STORAGE_TRANSFER_REQUEST_H__
#define __STORAGE_TRANSFER_REQUEST_H__

#include <storage/storage.h>

typedef enum
{
        TRANSFER_REQUEST_TYPE_READ  = 1,
        TRANSFER_REQUEST_TYPE_WRITE = 2
} TransferRequestType;

typedef struct
{
        ListNode                         requestList;
        Storage *                        storage;
        TransferRequestType              type;
        StorageBlock                     blockStart;
        uint8 *                          buffer;
        Size                             bufferSize;
        TransferRequestSuccessFunction * successFunction;
        void *                           successData;
        TransferRequestFailureFunction * failureFunction;
        void *                           failureData;
} TransferRequest;

extern Bool     transfer_request_create         (TransferRequest **,
                                                 Storage *,
                                                 TransferRequestType,
                                                 StorageBlock,
                                                 uint8 *,
                                                 Size,
                                                 TransferRequestSuccessFunction *,
                                                 void *,
                                                 TransferRequestFailureFunction *,
                                                 void *);
extern void     transfer_request_destroy        (void);

extern void     transfer_request_succeed        (TransferRequest *);
extern void     transfer_request_fail           (TransferRequest *);
extern void     transfer_request_cancel         (TransferRequest *);

#endif /* __STORAGE_TRANSFER_REQUEST_H__ */

