#ifndef __TIMER_PIT_H__
#define __TIMER_PIT_H__

#include <utility/types.h>

typedef enum
{
        PIT_REGISTER_COUNTER_0 = 0x40,
        PIT_REGISTER_COUNTER_1 = 0x41,
        PIT_REGISTER_COUNTER_2 = 0x42,
        PIT_REGISTER_COMMAND   = 0x43
} PITRegister;

typedef enum
{
	PIT_COMMAND_LATCH_COUNT          = 0,
	PIT_COMMAND_BINARY_CODED_DECIMAL = (1 << 0),
	PIT_COMMAND_READ_WRITE_LSB       = (1 << 4),
	PIT_COMMAND_READ_WRITE_MSB       = (1 << 5),
	PIT_COMMAND_SELECT_COUNTER_0     = (0 << 6),
	PIT_COMMAND_SELECT_COUNTER_1     = (1 << 6),
        PIT_COMMAND_SELECT_COUNTER_2     = (2 << 6)
} PITCommand;

enum
{
        PIT_FREQUENCY_BASE = 1193180
};

typedef uint32 PITFrequency;
typedef uint32 PITCounter;

typedef enum
{
	PIT_MODE_ALARM          = (0 << 1),
	PIT_MODE_ONE_SHOT       = (1 << 1),
	PIT_MODE_RATE_GENERATOR = (2 << 1),
	PIT_MODE_SQUARE_WAVE    = (3 << 1),
	PIT_MODE_SOFTWARE_PULSE = (4 << 1),
	PIT_MODE_HARDWARE_PULSE = (5 << 1)
} PITMode;

typedef void PITHandlerFunction (void);

extern void       pit_start       (PITFrequency, PITHandlerFunction *);
extern void       pit_stop        (void);
extern PITCounter pit_count       (void);

#endif /* __TIMER_PIT_H__ */

