#include <timer/time_offset.h>

void
time_offset_add (TimeOffset * result, const TimeOffset * offset)
{
    result -> seconds     += offset -> seconds;
    result -> nanoSeconds += offset -> nanoSeconds;

    if (result -> nanoSeconds >= NANOSECONDS_PER_SECOND)
    {
       result -> nanoSeconds -= NANOSECONDS_PER_SECOND;
       ++ result -> seconds;
    }
}

void
time_offset_subtract (TimeOffset * result, const TimeOffset * offset)
{
    result -> seconds -= offset -> seconds;

    if (result -> nanoSeconds < offset -> nanoSeconds)
    {
       -- result -> seconds;
       result -> nanoSeconds += NANOSECONDS_PER_SECOND;
    }

    result -> nanoSeconds -= offset -> nanoSeconds;
}

void
time_offset_normalize (TimeOffset * offset)
{
    offset -> seconds     += offset -> nanoSeconds / NANOSECONDS_PER_SECOND;
    offset -> nanoSeconds %= NANOSECONDS_PER_SECOND;
}

