#ifndef __UTILITY_STRING_H__
#define __UTILITY_STRING_H__

#include <utility/types.h>
#include <utility/arguments.h>

extern Size		string_length		(const char *);
extern Size		string_hash		(const char *);
extern Bool		string_equal		(const char *, const char *);
extern Compare		string_compare		(const char *, const char *);
extern char *		string_find		(const char *, const char *);

extern char *		string_copy		(char *, Size, const char *);
extern char *           string_duplicate        (const char *);
extern Size		string_format		(char *, Size, const char *, ...);
extern Size		string_format_arguments	(char *, Size, const char *, Arguments);
extern int		string_to_integer	(const char *);
extern char *		string_from_integer	(char *, Size, int);
extern char *		string_from_unsigned	(char *, Size, unsigned, Size);

#endif /* __UTILITY_STRING_H__ */

