#include <scheduler/thread.h>
#include <utility/memory.h>
#include <utility/string.h>
#include <vga/context.h>

static VGAContext testContext;

static void
vgaTest (void * data)
{
    vga_context_create (& testContext, VGA_MODE_IMAGE_640x480x4, NULL, NULL, NULL, NULL);

    vga_context_activate (& testContext);

    vga_context_set_override (& testContext, 0xC, 0xF);
    memory_set ((void *) 0xA0000, 0xFF, 528 * 480 / 8);
    
    vga_context_set_override (& testContext, 0x1, 0xF);
    memory_set ((void *) (0xA0000 + 528 * 480 / 8), 0xFF, 112 * 480 / 8);
    
    vga_context_set_override (& testContext, 0x8, 0x8);
    vga_context_set_logic (& testContext, VGA_LOGIC_XOR, 0xFF);
    memory_copy ((void *) (0xA0000 + 540 * 480 / 8), (void *) (0xA0000 + 540 * 480 / 8), 100 * 480 / 8);

    vga_context_set_write (& testContext, VGA_WRITE_INTERLEAVED, 0xF);
    vga_context_set_logic (& testContext, VGA_LOGIC_SET, 0xFF);
    memory_set ((void *) (0xA0000 + 200 * 480 / 8), 0x2, 40 * 480 / 8);
    
    vga_context_destroy (& testContext);

    vga_context_create (& testContext, VGA_MODE_IMAGE_320x200x8, NULL, NULL, NULL, NULL);

    vga_context_activate (& testContext);

    memory_set ((void *) 0xA0000, 0x2, 160 * 200);
    memory_set ((void *) (0xA0000 + 160 * 200), 0xC, 160 * 200);

    vga_context_destroy (& testContext);

    vga_context_create (& testContext, VGA_MODE_TEXT_80x25, NULL, NULL, NULL, NULL);

    vga_context_activate (& testContext);

    vga_context_set_cursor (& testContext, 0, 24);

    memory_zero ((void *) 0xB8000, 80 * 25 * 2);

    vga_context_destroy (& testContext);
}

Bool
__vga_test_enter__ (void)
{
    return thread_create (NULL, THREAD_PRIORITY_MAXIMUM, THREAD_PRIORITY_MAXIMUM, vgaTest, NULL, NULL, 0);
}

