BOOT=`grep -v '#' boot.txt | awk '{ printf "components/%s.xcom\n", $1, ".xcom" }'`

echo "Component: boot.xcom"
for X in ${BOOT};
do
   echo "  Boot component:" $X
done

./pidl -m -i components/ boot.pcom boot boot.pi

#./interface boot.interface boot `grep -v '#' boot.txt`

# Create the final xcom.
# Anchor the xcom so that it can be run from its loaded position at 0x100000
./xl -mzse -i boot.pcom@pos -A 0x100000 boot.xcom ${BOOT}

BOOT_INFORMATION=`./symval boot.xcom boot_information`
START_ADDRESS=`./symval boot.xcom _start`

echo "Makinge image.pos"
cp boot.xcom image.tail

for M in `grep -v '#' modules.txt`;
do
   echo "Component:" $M.xcom

   cat image.tail components/$M.xcom > image.tmp
   cp image.tmp image.tail
   rm image.tmp
done

IMAGE_SIZE=`./size image.tail`

echo "Size:" $IMAGE_SIZE "Load:" 0x100000 "Start:" 0x$START_ADDRESS "Information:" 0x$BOOT_INFORMATION

./header image.head $IMAGE_SIZE 0x100000 0x$START_ADDRESS 0x$BOOT_INFORMATION
cat image.head image.tail > image.pos


