CC="gcc -nostdinc -ansi -Wall -O3 -fomit-frame-pointer"
#CC=lcc
INCLUDE="-I../ -I../libc"
NASM=../../tools/nasm-0.98/nasm
NASM_INCLUDE="-i../"
XL=../xl
PIDL=../pidl
COMPONENTS=`grep -v '#' modules.txt`

echo "Making components."

cd components

for M in ${COMPONENTS}
do
   echo "Component:" $M.xcom
   cd $M
   
   if [ -r $M.sh ];
   then
      sh $M.sh
   else
      C=`ls *.c 2> /dev/null`
      if [ "${C}" ];
      then
         ${CC} -c ${C} ${INCLUDE}
      fi

      ASSEMBLY=`ls *.S 2> /dev/null`
      if [ "${ASSEMBLY}" ];
      then
         for FILE in ${ASSEMBLY};
         do
            ${NASM} -f xcom -o $FILE.o $FILE ${NASM_INCLUDE}
         done
      fi
   fi

   cd ..

   ${PIDL} -m $M.pcom $M $M/$M.pi 
   ${XL} -mse -i $M.pcom@pos -c ".bss" $M.xcom $M/*.o
done

cd ..

