#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <i386/boot.h>

int
main (int argc, char ** argv)
{
    FILE * output;
    i386BootHeader header;

    if (argc < 6)
      return EXIT_FAILURE;

    if (argc < 7)
      output = fopen (argv [1], "wb");
    else
      output = fopen (argv [1], "r+b");

    if (output == NULL)
      return EXIT_FAILURE;

    if (argc >= 7)
      fseek (output, atoi (argv [6]), SEEK_SET);

    strcpy (header.magic, I386_BOOT_MAGIC);

    sscanf (argv [2], "%i", (int *) & header.imageSize);
    sscanf (argv [3], "%i", (int *) & header.loadAddress);
    sscanf (argv [4], "%i", (int *) & header.startAddress);
    sscanf (argv [5], "%i", (int *) & header.informationAddress);

    fwrite (& header, sizeof (i386BootHeader), 1, output);

    fclose (output);

    return EXIT_SUCCESS;
}

