#include <stdlib.h>
#include "error.h"

static int verboseMessages = 0;

void
pidl_print (FILE * file, const char * format, va_list arguments)
{
       fprintf (file, "pidl: ");

       vfprintf (file, format, arguments);

       fputc ('\n', file);
}

void
pidl_verbose (int verbose)
{
       verboseMessages = verbose;
}

void
pidl_message (const char * format, ...)
{
       va_list arguments;

       if (verboseMessages != 0)
       {
           va_start (arguments, format);

           pidl_print (stdout, format, arguments);

           va_end (arguments);
       }
}

void
pidl_warning (const char * format, ...)
{
       va_list arguments;

       va_start (arguments, format);

       pidl_print (stderr, format, arguments);

       va_end (arguments);
}

void
pidl_error (const char * format, ...)
{
       va_list arguments;

       va_start (arguments, format);

       pidl_print (stderr, format, arguments);

       va_end (arguments);

       exit (EXIT_FAILURE);
}

