#include <stdlib.h>
#include "export.h"

Export *
export_create (Component * component, Interface * interface)
{
        Export * export;
        
        export = export_find (component, interface);
        if (export != NULL)
          return export;

        export = (Export *) malloc (sizeof (Export));
        if (export == NULL)
          return NULL;

        export -> interface = interface;

        list_insert_back (& component -> exports, export);

        return export;
}

void
export_destroy (Export * export)
{
        list_remove (& export -> exportList);

        free (export);
}

Export *
export_find (Component * component, Interface * interface)
{
        ListIterator position;

        for (position = list_begin (& component -> exports);
             position != list_end (& component -> exports);
             position = list_next (position))
        {
            Export * export = (Export *) position;

            if (export -> interface == interface)
              return export;
        }

        return NULL;
}

