#ifndef __PIDL_PIDL_H__
#define __PIDL_PIDL_H__

#include <stdio.h>
#include "value.h"
#include "namespace.h"

typedef struct
{
        Namespace       namespace;
        const char **   directories;
        size_t          directoryCount;
} PIDL;

extern int      pidl_create             (PIDL *);
extern void     pidl_destroy            (PIDL *);

extern int      pidl_add_directory      (PIDL *, const char *);
extern int      pidl_add_interface      (PIDL *, Value *);
extern int      pidl_add_component      (PIDL *, Value *);
extern int      pidl_include_file       (PIDL *, Value *);
extern int      pidl_import_file        (PIDL *, Value *);
extern FILE *   pidl_find_file          (PIDL *, const char *);

extern int      pidl_read               (PIDL *, FILE *, int);
extern int      pidl_write              (PIDL *, Component *, FILE *);
extern int      pidl_write_symbols      (PIDL *, List *, FILE *);

#endif /* __PIDL_PIDL_H__ */

