#include <stdlib.h>
#include <string.h>
#include "error.h"
#include "symbol.h"

Symbol *
symbol_create (List * list, const char * name, const char * alias)
{
        Symbol * symbol;
        
        if (list != NULL)
        {
           symbol = symbol_find (list, NULL, alias);

           if (symbol != NULL)
           {
              if (strcmp (symbol -> name, name) == 0)
                return symbol;

              pidl_error ("Conflicting names for alias %s", alias);
           }
        }

        symbol = (Symbol *) malloc (sizeof (Symbol));

        if (symbol == NULL)
          return NULL;

        symbol -> name  = name;
        symbol -> alias = alias;

        if (list != NULL)
          list_insert_back (list, symbol);

        return symbol;
}

void
symbol_destroy (Symbol * symbol)
{
        list_remove (& symbol -> symbolList);
        
        free (symbol);
}

Symbol *
symbol_find (List * list, const char * name, const char * alias)
{
        ListIterator position;

        for (position = list_begin (list);
             position != list_end (list);
             position = list_next (position))
        {
            Symbol * symbol = (Symbol *) position;
            
            if ((name == NULL ||
                 strcmp (symbol -> name, name) == 0) &&
                (alias == NULL ||
                 strcmp (symbol -> alias, alias) == 0))
              return symbol;
        }
        
        return NULL;
}

