#ifndef __XL_NAMESPACE_H__
#define __XL_NAMESPACE_H__

#include <stdlib.h>
#include <stdio.h>
#include "list.h"
#include "symbol.h"
#include "definition.h"

enum
{
        NAMESPACE_EMPTY_THRESHOLD = 2,
        NAMESPACE_GROWTH_SCALE    = 2,
        NAMESPACE_GROWTH_OFFSET   = 1,
        NAMESPACE_INITIAL_BUCKETS = 512
};

typedef struct
{
        List *        buckets;
        size_t        bucketCount;
        size_t        definitionCount;
} Namespace;

extern int              namespace_create         (Namespace *);
extern void             namespace_destroy        (Namespace *);

extern Definition *     namespace_find           (const Namespace *, const char *);
extern Definition *     namespace_insert         (Namespace *, const char *, Symbol *);
extern void             namespace_remove         (Namespace *, Definition *);

extern int              namespace_grow           (Namespace *, size_t);
extern void             namespace_clear          (Namespace *);

extern size_t           namespace_assign_offsets (Namespace *, int);
extern int              namespace_write          (Namespace *, FILE *);

#endif /* __XL_STRING_TABLE_H__ */

