#ifndef __XL_RELOCATION_H__
#define __XL_RELOCATION_H__

#include <stdlib.h>
#include "list.h"
#include "definition.h"

struct Symbol;
struct Object;

typedef enum
{
        RELOCATION_TYPE_ABSOLUTE_16 = 2,
        RELOCATION_TYPE_ABSOLUTE_32 = 3,
        RELOCATION_TYPE_RELATIVE_8  = 4,
        RELOCATION_TYPE_RELATIVE_16 = 5,
        RELOCATION_TYPE_RELATIVE_32 = 6
} RelocationType;

typedef struct
{
        ListNode        relocationList;
        RelocationType  type;
        size_t          offset;
        Definition *    definition;
        int             deferred;
} Relocation;

extern Relocation *     relocation_create       (List *, RelocationType, size_t, Definition *);
extern void             relocation_destroy      (Relocation *);

extern void             relocation_merge        (Relocation *, Section *);
extern void             relocation_move         (Relocation *, Section *, Object *, const char *);
extern void             relocation_fixup        (Relocation *, Section *, size_t);
extern int              relocation_relocate     (Relocation *, Section *, int);

#endif /* __XL_RELOCATION_H__ */

